//+------------------------------------------------------------------+
//|                                                   Bands+Fibo.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrBlue 
#property indicator_color2  clrGreen
#property indicator_color3  clrGreen
#property indicator_color4  clrRed 
#property indicator_color5  clrLightSeaGreen
#property indicator_color6  clrRed
#property indicator_color7  clrLightSeaGreen
#property indicator_style1  STYLE_DOT
#property indicator_width5  2
#property indicator_width7  2


//---- indicator parameters
extern int    BandsPeriod                = 20;
extern int    BandsShift                 = 0;
extern int    PeriodsATR                 = 20;

extern bool   AlertsandArrowsOnHighLow   = true;
extern bool   alertsOn                   = true;
extern bool   alertsOnLevel2Cross        = true;
extern bool   alertsOnLevel3Cross        = true;
extern bool   alertsOnCurrent            = false;
extern bool   alertsMessage              = true;
extern bool   alertsSound                = false;
extern bool   alertsEmail                = false;
extern bool   alertsNotify               = false;

extern bool   arrowsVisible              = true;
extern string arrowsIdentifier           = "atr fibo Arrows1";
extern double arrowsUpperGap             = 0.5;
extern double arrowsLowerGap             = 0.5;

extern bool   arrowsOnLevel2Cross        = false;
extern color  arrowsOnLevel2CrossUpColor = DeepSkyBlue;
extern color  arrowsOnLevel2CrossDnColor = Red;
extern int    arrowsOnLevel2CrossUpCode  = 233;
extern int    arrowsOnLevel2CrossDnCode  = 234;
extern int    arrowsOnLevel2CrossUpSize  = 1;
extern int    arrowsOnLevel2CrossDnSize  = 1;

extern bool   arrowsOnLevel3Cross        = false;
extern color  arrowsOnLevel3CrossUpColor = DeepSkyBlue;
extern color  arrowsOnLevel3CrossDnColor = Red;
extern int    arrowsOnLevel3CrossUpCode  = 233;
extern int    arrowsOnLevel3CrossDnCode  = 234;
extern int    arrowsOnLevel3CrossUpSize  = 1;
extern int    arrowsOnLevel3CrossDnSize  = 1;
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double UpperBuffer2[];
double UpperBuffer3[];
double LowerBuffer[];
double LowerBuffer2[];
double LowerBuffer3[];
double trend1[];
double trend2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexBuffer(2,LowerBuffer);
   SetIndexBuffer(3,UpperBuffer2);
   SetIndexBuffer(4,UpperBuffer3);
   SetIndexBuffer(5,LowerBuffer2);
   SetIndexBuffer(6,LowerBuffer3);
   SetIndexBuffer(7,trend1);
   SetIndexBuffer(8,trend2);
return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
      if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
return (0);
}

//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-1,Bars-counted_bars-1);
           
   //
   //
   //
   //
   //
   
   for (int i = limit; i >= 0; i--)
   {
      double deviation = iATR(NULL,0,PeriodsATR,i);
      MovingBuffer[i]  = iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
      
      UpperBuffer[i]   = MovingBuffer[i]+deviation*1.618;
      UpperBuffer2[i]  = MovingBuffer[i]+deviation*2.618;
      UpperBuffer3[i]  = MovingBuffer[i]+deviation*4.236;
      LowerBuffer[i]   = MovingBuffer[i]-deviation*1.618;
      LowerBuffer2[i]  = MovingBuffer[i]-deviation*2.618;
      LowerBuffer3[i]  = MovingBuffer[i]-deviation*4.236; 
      
         trend1[i] = 0;
         trend2[i] = 0;
         if (AlertsandArrowsOnHighLow)       
            {
               if (Low[i]<LowerBuffer2[i])  trend1[i] = 1;
               if (High[i]>UpperBuffer2[i]) trend1[i] =-1;
               if (Low[i]<LowerBuffer3[i])  trend2[i] = 1;
               if (High[i]>UpperBuffer3[i]) trend2[i] =-1;
            }
            else
            {
               if (Close[i]<LowerBuffer2[i]) trend1[i] = 1;
               if (Close[i]>UpperBuffer2[i]) trend1[i] =-1;
               if (Close[i]<LowerBuffer3[i]) trend2[i] = 1;
               if (Close[i]>UpperBuffer3[i]) trend2[i] =-1;
            }
         
      
         //
         //
         //
         //
         //
               
         if (arrowsVisible)
         {
            ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
            ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
            string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
            if (arrowsOnLevel2Cross && trend1[i] != trend1[i+1])
            {
               if (trend1[i] == 1) drawArrow("1",0.5,i,arrowsOnLevel2CrossUpColor,arrowsOnLevel2CrossUpCode,arrowsOnLevel2CrossUpSize,false);
               if (trend1[i] ==-1) drawArrow("1",0.5,i,arrowsOnLevel2CrossDnColor,arrowsOnLevel2CrossDnCode,arrowsOnLevel2CrossDnSize,true);
            } 
            if (arrowsOnLevel3Cross && trend2[i] != trend2[i+1]) 
            { 
               if (trend2[i] == 1) drawArrow("2",1.0,i,arrowsOnLevel3CrossUpColor,arrowsOnLevel3CrossUpCode,arrowsOnLevel3CrossUpSize,false);
               if (trend2[i] ==-1) drawArrow("2",1.0,i,arrowsOnLevel3CrossDnColor,arrowsOnLevel3CrossDnCode,arrowsOnLevel3CrossDnSize,true);                                              
            }         
     
          }
    }
manageAlerts();
return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      
      if (alertsOnLevel2Cross && trend1[whichBar] != trend1[whichBar+1])
      {
         static string   mess1 = "";
         static datetime time1 = 0;        
         if (trend1[whichBar] ==  1) doAlert(mess1,time1,whichBar,"price crossing second lower level");
         if (trend1[whichBar] == -1) doAlert(mess1,time1,whichBar,"price crossing second upper level");
      } 
      
      if (alertsOnLevel3Cross && trend2[whichBar] != trend2[whichBar+1])
      {
         static string   mess2 = "";
         static datetime time2 = 0;        
         if (trend2[whichBar] == 1)  doAlert(mess2,time2,whichBar,"price crossing third lower level");
         if (trend2[whichBar] ==-1)  doAlert(mess2,time2,whichBar,"price crossing third upper level");
         
      }                 
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Atr fibo bands ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Atr fibo bands "),message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,int theSize, bool up)
{
   string tname = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap   = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(tname,OBJ_ARROW,0,Time[i],0);
         ObjectSet(tname,OBJPROP_ARROWCODE,theCode);
         ObjectSet(tname,OBJPROP_COLOR,theColor);
         ObjectSet(tname,OBJPROP_WIDTH,theSize );  
         if (up)
               ObjectSet(tname,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(tname,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

